### ****************
###  Arg Comments
### ****************

{% macro arg_to_comment(arg) %}
{% if arg.spec.isInput %}
  {% if arg.spec.isArray %}
 * @param {{arg.name}}
 * @param {{arg.name}}_size: size of the input {{arg.name}} array,
 * must be set to {{arg.spec.arraySize}}
  {% elif arg.spec.isPayload %}
 * @param {{arg.name}}
 * @param {{arg.name}}_size: size of the input {{arg.name}} array
  {% elif arg.xref %}
    {% for field in arg.xref.fields %}
 * @param {{field.name}}
    {% endfor %}
  {% else %}
 * @param {{arg.name}}
  {% endif %}
{%- else %}
  {% if arg.spec.isPayload %}
 * @param[out] {{arg.name}}
 * @param[out] {{arg.name}}_buf_size: size of the output {{arg.name}} array
 * @param[out] {{arg.name}}_size: number of bytes written into the output array
  {% elif arg.xref %}
    {% for field in arg.xref.fields %}
 * @param[out] {{field.name}}
    {% endfor %}
  {% else %}
 * @param[out] {{arg.name}}
  {% endif %}
{%- endif %}
{%- endmacro %}

### *******************
###  Method  Comments
### *******************

{% macro comment(impl_name, method) %}
/**
 * {{impl_name}}_{{method.name}}()
 *
{% for arg in method.args %}
{{arg_to_comment(arg)}}
{%- endfor %}
{% if method.args|length > 0 %}
 *
{% endif %}
 * @return: 0 on success, or an error code < 0 on failure.
 */
{%- endmacro %}

### ****************
###  Arg Signature
### ****************

{% macro arg_to_c(arg) %}
{% if arg.spec.isInput %}
  {% if arg.spec.isArray %}
    uint8_t* {{arg.name}},
    size_t {{arg.name}}_size
  {% elif arg.spec.isPayload %}
    uint8_t* {{arg.name}},
    size_t {{arg.name}}_size
  {% elif arg.xref %}
    {% for field in arg.xref.fields %}
    {{field.qualType}} {{field.name}} {{ "," if not loop.last else "" }}
    {% endfor %}
  {% else %}
    {{arg.qualType}} {{arg.name}}
  {% endif %}
{% else %}
  {% if arg.spec.isPayload %}
    uint8_t* {{arg.name}},
    size_t {{arg.name}}_buf_size,
    size_t* {{arg.name}}_size
  {% elif arg.xref %}
    {% for field in arg.xref.fields %}
    {{field.qualType}}* {{field.name}} {{ "," if not loop.last else "" }}
    {% endfor %}
  {% else %}
    {{arg.qualType}} {{arg.name}}
  {% endif %}
{%- endif %}
{%- endmacro %}

### *******************
###  Method  Signature
### *******************

{% macro signature(impl_name, method, hdr) %}
{% if not hdr %}
extern "C"{{" "}}
{%- endif %}
{% if method.args|length == 0 %}
int {{impl_name}}_{{method.name}}(void)
{%- else %}
int {{impl_name}}_{{method.name}}(
{% for arg in method.args %}
{{arg_to_c(arg)}}{{ "," if not loop.last else "" }}
{%- endfor %}
)
{%- endif %}
{%- endmacro %}


### *******************************************************
###  Arg Prolog: Initialisation prior to method invocation
### *******************************************************

{% macro arg_prolog(iface_name, domain, arg) %}
{% if arg.spec.isInput %}
  {% if arg.spec.isArray %}
    if ({{arg.name}}_size != {{arg.spec.arraySize}}) {
        TLOGE("{{arg.name}} is not its expected size {{arg.spec.arraySize}}.\n");
        return ERR_BAD_LEN;
    }

    {{arg.qualType.replace("&", "")}} {{arg.name}}_array;
    memcpy({{arg.name}}_array.data(), {{arg.name}}, {{arg.name}}_array.size());

  {% elif arg.spec.isPayload %}
    if ({{arg.name}}_size > aidl::{{iface_name}}::MAX_PAYLOAD_REQ) {
        TLOGE("{{arg.name}} exceeds aidl::{{iface_name}}::MAX_PAYLOAD_REQ limit.\n");
        return ERR_BAD_LEN;
    }

    const trusty::aidl::Payload {{arg.name}}_payload{const_cast<uint8_t*>({{arg.name}}),
                                      static_cast<uint32_t>({{arg.name}}_size)};

  {% elif arg.xref %}
    const {{arg.qualType.replace(" &","")}} {{arg.name}} = {
    {% for field in arg.xref.fields %}
       .{{field.name}} = {{field.name}}{{ "," if not loop.last else "" }}
    {% endfor %}
    };
  {% endif %}
{% else %}
  {% if arg.spec.isPayload %}
    if ({{arg.name}}_size > aidl::{{iface_name}}::MAX_PAYLOAD_RESP) {
        TLOGE("{{arg.name}} exceeds aidl::{{iface_name}}::MAX_PAYLOAD_RESP limit.\n");
        return ERR_BAD_LEN;
    }

    trusty::aidl::Payload {{arg.name}}_payload{const_cast<uint8_t*>({{arg.name}}),
                                      static_cast<uint32_t>({{arg.name}}_buf_size)};
  {% elif arg.xref %}
    {% for field in arg.xref.fields %}
    assert({{field.name}});
    {% endfor %}
    {{arg.qualType.replace(" *","")}} {{arg.name}};
  {% endif %}
{%- endif %}
{%- endmacro %}


### *******************************************************
###  Arg Epilog: Update after method invocation
### *******************************************************

{% macro arg_epilog(arg) %}
{% if not arg.spec.isInput %}
  {% if arg.spec.isPayload %}
    *{{arg.name}}_size = {{arg.name}}_payload.size();
  {% elif arg.xref %}
    {% for field in arg.xref.fields %}
    *{{field.name}} = {{arg.name}}.{{field.name}};
    {% endfor %}
  {% endif %}
{%- endif %}
{%- endmacro %}

### ****************
###  Arg Invoke
### ****************

{% macro arg_invoke(arg) %}
{% if arg.spec.isInput %}
  {% if arg.spec.isArray %}
        {{arg.name}}_array
  {% elif arg.spec.isPayload %}
        {{arg.name}}_payload
  {% elif arg.xref %}
        {{arg_name}}
  {% else %}
        {{arg.name}}
  {% endif %}
{% else %}
  {% if arg.spec.isPayload %}
        &{{arg.name}}_payload
  {% elif arg.xref %}
        &{{arg.name}}
  {% else %}
        {{arg.name}}
  {% endif %}
{%- endif %}
{%- endmacro %}
